<?php namespace Grafika\Search;

use Backend;
use System\Classes\PluginBase;
use Event;
use Grafika\Search\Classes\Event\Product\ExtendProductCollection;

/**
 * Search Plugin Information File
 */
class Plugin extends PluginBase
{
    /**
     * Returns information about this plugin.
     *
     * @return array
     */
    public function pluginDetails()
    {
        return [
            'name'        => 'Search',
            'description' => 'No description provided yet...',
            'author'      => 'Grafika',
            'icon'        => 'icon-leaf'
        ];
    }

    /**
     * Register method, called when the plugin is first registered.
     *
     * @return void
     */
    public function register()
    {

    }

    /**
     * Boot method, called right before the request route.
     *
     * @return array
     */
    public function boot()
    {
		Event::subscribe(ExtendProductCollection::class);
    }

    /**
     * Registers any front-end components implemented in this plugin.
     *
     * @return array
     */
    public function registerComponents()
    {
        return []; // Remove this line to activate

        return [
            'Grafika\Search\Components\MyComponent' => 'myComponent',
        ];
    }

    /**
     * Registers any back-end permissions used by this plugin.
     *
     * @return array
     */
    public function registerPermissions()
    {
        return []; // Remove this line to activate

        return [
            'grafika.search.some_permission' => [
                'tab' => 'Search',
                'label' => 'Some permission'
            ],
        ];
    }

    /**
     * Registers back-end navigation items for this plugin.
     *
     * @return array
     */
    public function registerNavigation()
    {
        return []; // Remove this line to activate

        return [
            'search' => [
                'label'       => 'Search',
                'url'         => Backend::url('grafika/search/mycontroller'),
                'icon'        => 'icon-leaf',
                'permissions' => ['grafika.search.*'],
                'order'       => 500,
            ],
        ];
    }
}
